/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/* DERDEI.MC - Maxima Package - v.20090402 - Maxima 5.38.1                */
/*                                                                        */
/* Copyright (c) 2009-2019 Nikolitsa Giannopoulou OE3ZGN|SV7DMC and       */
/* Petros Zimourtopoulos OE3ZZP|SV7BAX - Austria EU - www.op4.eu -        */
/*                                                                        */
/* Permission is hereby granted, free of charge, to any person obtaining  */
/* a copy of this software and associated documentation files (the        */
/* "Software"), to deal in the Software without restriction, including    */
/* distribute, sublicense, and/or sell copies of the Software, and to     */
/* permit persons to whom the Software is furnished to do so, subject to  */
/* the following conditions:                                              */
/*                                                                        */
/* The above copyright notice and this permission notice shall be         */
/* included in all copies or substantial portions of the Software.        */
/*                                                                        */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,        */
/* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF     */
/* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. */
/* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY   */
/* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,   */
/* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE      */
/* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                 */
/*                                                                        */
/* /F/L/O/S/S/ Free Libre Open Source Software under "The MIT License"    */
/* approved by OSI Open Source Initiative www.opensource.org              */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */
/* Version : 20190921 - Maxima : 5.38.1                                   */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  */

load(numericalio);
der(pointline,arc):=block(m:read_matrix(pointline),k:makelist([m[i,2],m[i,3]],i,1,49),n:makelist([m[i,2],m[i,3]],i,50,73),kk:makelist([discrete,[k[part(n[i]+1,1)],k[part(n[i]+1,2)]]],i,1,24),rec:[[discrete,[[m[74,2],m[75,2]],[m[74,2],m[75,3]]]],[discrete,[[m[74,2],m[75,2]],[m[74,3],m[75,2]]]],[discrete,[[m[74,3],m[75,2]],[m[74,3],m[75,3]]]],[discrete,[[m[74,2],m[75,3]],[m[74,3],m[75,3]]]],[discrete,[[m[76,2]*cos(m[77,2]),m[76,2]*sin(m[77,2])],[m[76,3]*cos(m[77,2]),m[76,3]*sin(m[77,2])]]],[discrete,[[m[76,2]*cos(m[77,3]),m[76,2]*sin(m[77,3])],[m[76,3]*cos(m[77,3]),m[76,3]*sin(m[77,3])]]]],c:read_matrix(arc),plot2d([[discrete,k],kk[1],kk[2],kk[3],kk[4],kk[5],kk[6],kk[7],kk[8],kk[9],kk[10],kk[11],kk[12],kk[13],kk[14],kk[15],kk[16],kk[17],kk[18],kk[19],kk[20],kk[21],kk[22],kk[23],kk[24],[parametric,c[1,6]*cos(t)+c[1,4],c[1,6]*sin(t)+c[1,5],[t,c[1,7],c[1,8]]],[parametric,c[2,6]*cos(t)+c[2,4],c[2,6]*sin(t)+c[2,5],[t,c[2,7],c[2,8]]],[parametric,c[3,6]*cos(t)+c[3,4],c[3,6]*sin(t)+c[3,5],[t,c[3,7],c[3,8]]],[parametric,c[4,6]*cos(t)+c[4,4],c[4,6]*sin(t)+c[4,5],[t,c[4,7],c[4,8]]],[parametric,c[5,6]*cos(t)+c[5,4],c[5,6]*sin(t)+c[5,5],[t,c[5,7],c[5,8]]],[parametric,c[6,6]*cos(t)+c[6,4],c[6,6]*sin(t)+c[6,5],[t,c[6,7],c[6,8]]],[parametric,c[7,6]*cos(t)+c[7,4],c[7,6]*sin(t)+c[7,5],[t,c[7,7],c[7,8]]],[parametric,c[8,6]*cos(t)+c[8,4],c[8,6]*sin(t)+c[8,5],[t,c[8,7],c[8,8]]],[parametric,c[9,6]*cos(t)+c[9,4],c[9,6]*sin(t)+c[9,5],[t,c[9,7],c[9,8]]],[parametric,c[10,6]*cos(t)+c[10,4],c[10,6]*sin(t)+c[10,5],[t,c[10,7],c[10,8]]],[parametric,c[11,6]*cos(t)+c[11,4],c[11,6]*sin(t)+c[11,5],[t,c[11,7],c[11,8]]],[parametric,c[12,6]*cos(t)+c[12,4],c[12,6]*sin(t)+c[12,5],[t,c[12,7],c[12,8]]],[parametric,c[13,6]*cos(t)+c[13,4],c[13,6]*sin(t)+c[13,5],[t,c[13,7],c[13,8]]],[parametric,c[14,6]*cos(t)+c[14,4],c[14,6]*sin(t)+c[14,5],[t,c[14,7],c[14,8]]],[parametric,c[15,6]*cos(t)+c[15,4],c[15,6]*sin(t)+c[15,5],[t,c[15,7],c[15,8]]],[parametric,c[16,6]*cos(t)+c[16,4],c[16,6]*sin(t)+c[16,5],[t,c[16,7],c[16,8]]],[parametric,c[17,6]*cos(t)+c[17,4],c[17,6]*sin(t)+c[17,5],[t,c[17,7],c[17,8]]],[parametric,c[18,6]*cos(t)+c[18,4],c[18,6]*sin(t)+c[18,5],[t,c[18,7],c[18,8]]],[parametric,c[19,6]*cos(t)+c[19,4],c[19,6]*sin(t)+c[19,5],[t,c[19,7],c[19,8]]],[parametric,c[20,6]*cos(t)+c[20,4],c[20,6]*sin(t)+c[20,5],[t,c[20,7],c[20,8]]],[parametric,c[21,6]*cos(t)+c[21,4],c[21,6]*sin(t)+c[21,5],[t,c[21,7],c[21,8]]],[parametric,c[22,6]*cos(t)+c[22,4],c[22,6]*sin(t)+c[22,5],[t,c[22,7],c[22,8]]],[parametric,c[23,6]*cos(t)+c[23,4],c[23,6]*sin(t)+c[23,5],[t,c[23,7],c[23,8]]],[parametric,c[24,6]*cos(t)+c[24,4],c[24,6]*sin(t)+c[24,5],[t,c[24,7],c[24,8]]],part(rec,1),part(rec,2),part(rec,3),part(rec,4),part(rec,5),part(rec,6),[parametric,m[76,2]*cos(t),m[76,2]*sin(t),[t,m[77,2],m[77,3]]],[parametric,m[76,3]*cos(t),m[76,3]*sin(t),[t,m[77,2],m[77,3]]]],[x,m[74,2]-0.05,m[74,3]+0.05],[y,m[75,2]-0.05,m[75,3]+0.05],[xlabel,"Real_Part"],[ylabel,"Imag_Part"],[gnuplot_preamble,"set size ratio 1.3"],[style,[points,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,0],[lines,3,2],[lines,3,2],[lines,3,2],[lines,3,2],[lines,3,1],[lines,3,1],[lines,3,1],[lines,3,1]],[nticks,80],[legend,false]));
print("der(filename-xxxxR.TXT,filename-xxxxA.TXT): plots the complex DER");

deisRM(rdeis,n,labx,laby):=block(g:read_matrix(rdeis),g1:makelist([g[i,1],g[i,2]],i,1,n),g2:makelist([g[i,1],g[i,3]],i,1,n), g3:makelist([g[i,1],g[i,4]],i,1,n), plot2d([[discrete,g1],[discrete,g2],[discrete,g3]],[xlabel,labx],[ylabel,laby],[gnuplot_preamble,"set size ratio 1."],[style,[points,1,1],[lines,3,0],[lines,3,0]],[legend,false]));
print("deisRM(filename-deis(RDEIS.TXT,PDEIS.TXT),n(number of frequencies),labelx,labely): plots the DEIs of Real Part or Magnitude vs Frequency");
deisIA(rdeis,n,labx,laby):=block(g:read_matrix(rdeis),g1:makelist([g[i,1],g[i,5]],i,1,n),g2:makelist([g[i,1],g[i,6]],i,1,n),g3:makelist([g[i,1],g[i,7]],i,1,n), plot2d([[discrete,g1],[discrete,g2],[discrete,g3]],[xlabel,labx],[ylabel,laby],[gnuplot_preamble,"set size ratio 1."],[style,[points,1,1],[lines,3,0],[lines,3,0]],[legend,false]));
print("deisIA(filename-deis(RDEIS.TXT,PDEIS.TXT),n(number of frequencies),labelx,labely): plots the DEIs of Imaginary Part or Argument vs Frequency");

deis(pdeis,n,labx,laby):=block(g:read_matrix(pdeis),g1:makelist([g[i,1],g[i,2]],i,1,n),g2:makelist([g[i,1],g[i,3]],i,1,n), g3:makelist([g[i,1],g[i,4]],i,1,n), g4:makelist([g[i,1],g[i,5]],i,1,n), g5:makelist([g[i,1],g[i,6]],i,1,n), g6:makelist([g[i,1],g[i,7]],i,1,n), plot2d([[discrete,g1],[discrete,g2],[discrete,g3],[discrete,g4],[discrete,g5],[discrete,g6]],[xlabel,labx],[ylabel,laby],[gnuplot_preamble,"set size ratio 1.4"],[style,[points,1,1,1],[lines,3,0],[lines,3,0],[points,1,2,1],[lines,3,5],[lines,3,5]],[legend,false]));
print("deis(filename-deis(RDEIS.TXT,PDEIS.TXT),n(number of frequencies),labelx,labely): plots the DEIS of Real and Imaginary Parts together or Magnitude and Argument together, vs Frequency");

